;PREPSANE PROGRAMOVATELNE KLAVESY
;
            LIST      P=16F84, F=INHX8M
;            include "P16FXX.inc"
;
; Programovatelne klavesy
;
pk_PF1	 equ	.240	
pk_PF2	 equ	.241
pk_PF3	 equ	.242
pk_PF4	 equ	.243
pk_PF5	 equ	.244
pk_PF6	 equ	.245
pk_PF7	 equ	.246
pk_PF8	 equ	.247
pk_PF9	 equ	.248
pk_PF10	 equ	.249
pk_PF11	 equ	.250
pk_PF12	 equ	.251
pk_PF13	 equ	.252
pk_PF14	 equ	.253
;
;

            ORG     0x0000

            GOTO    Label_0001
;
; Konverzia SCAN kodov >6F na kody do 6F
;
Label_0027  ADDWF   PCL       , f
            RETLW   0x68	;NB0
            RETLW   0x6F	;NB.
            RETLW   0x6A	;NB2
            RETLW   0x67	;NB5
            RETLW   0x65	;NB6
            RETLW   0x6D	;NB8
            RETLW   0x13	;ESC
            RETLW   0x57	;NUM LOCK
            RETLW   0x08	;F11
            RETLW   0x63	;NB+
            RETLW   0x64	;NB3
            RETLW   0x62	;NB-
            RETLW   0x60	;NB*
            RETLW   0x6E	;NB9
            RETLW   0x56	;SCROL LOCK
            RETLW   0x50	;Nedefinov.
;
;******************************
;
; Konverzia SCAN kodu na SCAN kod. Najprv NOVA hodnota, potom STARA
;
Label_0008  MOVF    0x20      , W
            ADDWF   0x21      , W
            ADDWF   PCL       , f
            NOP
;
; kody s E0 editacne
;
	retlw	0x5E		;NB /
	retlw	0x4A

	retlw	0x18		;END
	retlw	0x69

	retlw	0x38		;CURR LEFT
	retlw	0x6B

	retlw	0x17		;HOME
	retlw	0x6C

	retlw	0x19		;INSERT
	retlw	0x70

	retlw	0x20		;DELETE
	retlw	0x71

	retlw	0x40		;CURR DOWN
	retlw	0x72

	retlw	0x39		;CURR RIGHT
	retlw	0x74

	retlw	0x3F		;CURR UP
	retlw	0x75

	retlw	0x48		;PAGE DOWN
	retlw	0x7A

	retlw	0x28		;PRINT SCREER
	retlw	0x7C

	retlw	0x47		;PAGE UP
	retlw	0x7D

;
; konverzia SCAN na ZX pri konverzii klaves ~,_,... so SHIFT okrem 0..9
;
            RETLW   0xC9
            RETLW   0x0E

            RETLW   0x54
            RETLW   0x4E

            RETLW   0x66
            RETLW   0x55

            RETLW   0xE1
            RETLW   0x54

            RETLW   0xE9
            RETLW   0x5B

            RETLW   0x58
            RETLW   0x4C

            RETLW   0x55
            RETLW   0x52

            RETLW   0xD1
            RETLW   0x5D

            RETLW   0x6A
            RETLW   0x41

            RETLW   0x72
            RETLW   0x49

            RETLW   0x68
            RETLW   0x4A

;
; 2. stupen klavesy 1..0 so SHIFT, vysledok=klavesa ZX
;

            RETLW   0x53
            RETLW   0x16

            RETLW   0x5B
            RETLW   0x1E

            RETLW   0x63
            RETLW   0x26

            RETLW   0x6B
            RETLW   0x25

            RETLW   0x73
            RETLW   0x2E

            RETLW   0x76
            RETLW   0x36

            RETLW   0x74
            RETLW   0x3D

            RETLW   0x77
            RETLW   0x3E

            RETLW   0x64
            RETLW   0x46

            RETLW   0x5C
            RETLW   0x45
;
;*************
;
; Tabulka konverzie SCAN->ZX (kody 1..127)
;
Label_003A  MOVF    0x0C      , W
            ADDWF   PCL       , f

            RETLW   0xFF
            RETLW   pk_PF9 ;01 F9
            RETLW   pk_PF7 ;02 F7
            RETLW   pk_PF5 ;03 F5
            RETLW   pk_PF3 ;04 F3
            RETLW   pk_PF1 ;05 F1
            RETLW   pk_PF2 ;06 F2
            RETLW   0xFF   ;07 F12
            RETLW   0xFF   ;08 F11
            RETLW   0xFF   ;09 F10
            RETLW   pk_PF8 ;0A F8
            RETLW   pk_PF6 ;0B F6
            RETLW   pk_PF4 ;0C F4
            RETLW   0x37   ;0D TAB (2B puvodne)
            RETLW   0x60   ;0E `~  (60 puvodne)
            RETLW   0xFF   ;0F PAUSE
            RETLW   0xFF
            RETLW   0x0F   ;11 ALT (0F puvodne)
            RETLW   0x00   ;12 SHIFT L
            RETLW   0x2F   ;13 ESC
            RETLW   pk_PF14 ;14 CTRL (37 puvodne)
            RETLW   0x02
            RETLW   0x03
            RETLW   0x52   ;17 HOME
            RETLW   0x62   ;18 END
            RETLW   0x5A   ;19 INS
            RETLW   0x08
            RETLW   0x09
            RETLW   0x01
            RETLW   0x0A
            RETLW   0x0B
            RETLW   0x2E   ;1F WIN95 LW (FF puvodne)
            RETLW   0x34   ;20 DEL
            RETLW   0x18
            RETLW   0x10
            RETLW   0x11
            RETLW   0x12
            RETLW   0x1B
            RETLW   0x13
            RETLW   0x56   ;27 WIN95 RW (FF puvodne)
            RETLW   0xDE   ;28 PRINT SCR (FF puvodne)
            RETLW   0x07   ;29 SPACE
            RETLW   0x20
            RETLW   0x19
            RETLW   0x22
            RETLW   0x1A
            RETLW   0x23
            RETLW   0X57 ;2F WIN95 menu (FF puvodne)
            RETLW   0xFF
            RETLW   0x1F
            RETLW   0x27
            RETLW   0x26
            RETLW   0x21
            RETLW   0x25
            RETLW   0x24
            RETLW   0xFF
            RETLW   pk_PF10 ;38 CURR LEFT
            RETLW   pk_PF11 ;39 CURR RIGHT
            RETLW   0x17
            RETLW   0x1E
            RETLW   0x1D
            RETLW   0x1C
            RETLW   0x14
            RETLW   pk_PF12 ;3F CURR UP
            RETLW   pk_PF13 ;40 CURR DW
            RETLW   0x6F
            RETLW   0x16
            RETLW   0x15
            RETLW   0x0D
            RETLW   0x04
            RETLW   0x0C
            RETLW   0x3B   ;47	PG UP (FC puvodne) 
            RETLW   0x43   ;48	PG DW (FD puvodne)
            RETLW   0x67
            RETLW   0x70
            RETLW   0x0E
            RETLW   0x5D
            RETLW   0x05
            RETLW   0x6E
            RETLW   0xFF
            RETLW   0xFF
            RETLW   0xFF
            RETLW   0x6C
            RETLW   0xFF
            RETLW   0xED
            RETLW   0x5E
            RETLW   0xFF   ;56 SCROLL LOCK
            RETLW   0xFF   ;57 NUM LOCK
            RETLW   0x33   ;58 CAPS LOCK
            RETLW   0x00   ;59 SHIFT R
            RETLW   0x06   ;5A ENTER
            RETLW   0xE5
            RETLW   0xFF
            RETLW   0xD9
            RETLW   0x70
            RETLW   0xFF   ;5F ALT+PRNT_SCR
            RETLW   0x77
            RETLW   0x5A
            RETLW   0x6E
            RETLW   0x66
            RETLW   0x13
            RETLW   0x24
            RETLW   0x2C
            RETLW   0x23
            RETLW   0x04   ;68 NB 0
            RETLW   0x03
            RETLW   0x0B
            RETLW   0x1B
            RETLW   0x1C
            RETLW   0x14
            RETLW   0x0C
            RETLW   0x67   ;6F	NB .
;
;*****
;
; Citanie bitovej masky bitu W
;
Label_0046  ANDLW   0x07
            ADDWF   PCL       , f
            RETLW   0x01
            RETLW   0x02
            RETLW   0x04
            RETLW   0x08
            RETLW   0x10
            RETLW   0x20
            RETLW   0x40
            RETLW   0x80
;
;*************************
;
; Druha polovica PAMATE - STRANKA 1
;
;*************************
;
;
	;!!!!!!!!!org	0x1FF
;
;**********************
;
; Podprogramy
;
;**********************
;
;
; Nulovanie MATICE (72T)
;
Label_001C  CLRF    0x0D
            CLRF    0x0E
            CLRF    0x0F
            CLRF    0x10
            CLRF    0x11
            MOVLW   0x80
            ANDWF   0x23      , f
            CLRF    PORTB
Label_0002  BSF     PORTB     , 06
            BCF     PORTB     , 06
            BSF     PORTB     , 07
            BCF     PORTB     , 07
            INCF    PORTB     , f
            BTFSS   PORTB     , 03
            GOTO    Label_0002
            RETLW   0x00
;
;********
;
; Poslanie pamate matice do 8804 okrem MC7 (284T)
;
Label_0044  MOVLW   0x01
            MOVWF   0x20
            CLRF    PORTB
            BCF     STATUS    , C

Label_0003  MOVF    0x20      , W
            ANDWF   0x0D      , W
            BTFSS   STATUS    , Z
            BSF     PORTB     , 03

            MOVF    0x20      , W
            ANDWF   0x0E      , W
            BTFSS   STATUS    , Z
            BSF     PORTB     , 04

            MOVF    0x20      , W
            ANDWF   0x0F      , W
            BTFSS   STATUS    , Z
            BSF     PORTB     , 05

            BSF     PORTB     , 06
            BCF     PORTB     , 06

            MOVLW   0x07
            ANDWF   PORTB     , f

            MOVF    0x20      , W
            ANDWF   0x10      , W
            BTFSS   STATUS    , Z
            BSF     PORTB     , 03

            MOVF    0x20      , W
            ANDWF   0x11      , W
            BTFSS   STATUS    , Z
            BSF     PORTB     , 04

            BSF     PORTB     , 07
            BCF     PORTB     , 07

            INCF    PORTB     , f

            MOVLW   0x07
            ANDWF   PORTB     , f

            RLF     0x20      , f
            BTFSS   STATUS    , C
            GOTO    Label_0003
            RETLW   0x00
;	 
;********************
;
; PAUZY a pauzicky ....
;
Label_0045  MOVLW   0x01
;
; Pauza Wx1ms.
; Ak pF0=1       => RETLW. (Pri pustani klaves netreba cakat)
; Ak RTTC<>0     => RETLW. (Ak pride prikaz treba akceptovat)
;
Label_004D  MOVWF   0x21
            BTFSC   STATUS    , RP1
            RETLW   0x00
Label_0005  MOVLW   0x7D
            MOVWF   0x20
Label_0004  MOVF    TMR0      , W
            BTFSS   STATUS    , Z
            RETLW   0x00
            DECFSZ  0x20      , f
            GOTO    Label_0004
            DECFSZ  0x21      , f
            GOTO    Label_0005
            RETLW   0x00
Label_0015  MOVLW   0xA4
            MOVWF   0x20
Label_0006  DECFSZ  0x20      , f
            GOTO    Label_0006
            RETLW   0x00
Label_0043  BCF     0x0D      , 00
            MOVLW   0x0F
            ANDWF   0x23      , W
            BTFSS   STATUS    , Z
            GOTO    Label_0007
            BTFSS   0x22      , 05
            BTFSS   STATUS    , RP1
Label_0007  BSF     0x0D      , 00
            RETLW   0x00
Label_0025  MOVWF   0x20
Label_000A  CALL    Label_0008
            DECF    0x20      , f
            SUBWF   0x0C      , W
            BTFSC   STATUS    , Z
            GOTO    Label_0009
            DECFSZ  0x20      , f
            GOTO    Label_000A
            GOTO    Label_000B
Label_0009  CALL    Label_0008
            MOVWF   0x0C
Label_000B  RETLW   0x00
Label_000E  CLRWDT
            MOVF    TMR0      , W
            MOVWF   0x21
            MOVLW   0x28
            MOVWF   0x20
            BSF     PORTA     , 02
Label_000D  BTFSS   PORTA     , 00
            GOTO    Label_000C
            DECFSZ  0x20      , f
            GOTO    Label_000D
            MOVF    TMR0      , W
            BTFSC   STATUS    , Z
            GOTO    Label_000E
            XORWF   0x21      , W
            BTFSS   STATUS    , Z
            GOTO    Label_000E
            BCF     PORTA     , 02
            GOTO    Label_000F
Label_000C  BSF     PORTA     , 02
            CALL    Label_0010
            BTFSC   PORTA     , 01
            GOTO    Label_0011
            MOVLW   0x09
            MOVWF   0x20
Label_0012  CALL    Label_0010
            RRF     0x0C      , f
            BCF     STATUS    , C
            BTFSC   PORTA     , 01
            BSF     STATUS    , C
            DECFSZ  0x20      , f
            GOTO    Label_0012
            CALL    Label_0010
            BTFSS   PORTA     , 01
            GOTO    Label_0011
            BCF     PORTA     , 02
            MOVLW   0xFA
            SUBWF   0x0C      , W
            RETLW   0x00
Label_0011  GOTO    Label_0013
Label_0010  BTFSC   PORTA     , 00
            GOTO    Label_0010
Label_0014  BTFSS   PORTA     , 00
            GOTO    Label_0014
            RETLW   0x00
Label_001B  MOVWF   0x0C
            BCF     PORTA     , 02
            CALL    Label_0015
            BCF     PORTA     , 03
            CALL    Label_0015
            BSF     PORTA     , 02
            CALL    Label_0016
            MOVLW   0x0A
            MOVWF   0x20
Label_0017  BTFSC   PORTA     , 00
            GOTO    Label_0017
            BTFSS   0x0C      , 00
            BCF     PORTA     , 03
            BTFSC   0x0C      , 00
            BSF     PORTA     , 03
            CALL    Label_0014
            RRF     0x0C      , f
            BSF     STATUS    , C
            DECFSZ  0x20      , f
            GOTO    Label_0017
            CALL    Label_0010
            BTFSC   PORTA     , 01
            GOTO    Label_0011
            GOTO    Label_000C
Label_0016  SWAPF   0x0C      , W
            XORWF   0x0C      , W
            MOVWF   0x20
            RRF     0x20      , f
            RRF     0x20      , f
            XORWF   0x20      , W
            MOVWF   0x20
            RRF     0x20      , f
            XORWF   0x20      , f
            MOVLW   0x01
            XORWF   0x20      , f
            RRF     0x20      , f
            RETLW   0x00
;
;****************
;
; Inicializacia programovatelnych klaves
;
Label_001A  MOVLW   0x2B ;pCS+zx_1
            MOVWF   0x12 ;F1 (pk_PF1)

            MOVLW   0x33 ;pCS+zx_2
            MOVWF   0x13 ;F2

            MOVLW   0x3B ;pCS+zx_3
            MOVWF   0x14 ;F3

            MOVLW   0x43 ;pCS+zx_4
            MOVWF   0x15 ;F4

            MOVLW   0xD4 ;pEXT_SS+zx_9
            MOVWF   0x16 ;F5

            MOVLW   0xEC ;pEXT_SS+zx_6
            MOVWF   0x17 ;F6

            MOVLW   0xE4 ;pEXT_SS+zx_7
            MOVWF   0x18 ;F7

            MOVLW   0xCC ;pEXT_SS+zx_0
            MOVWF   0x19 ;F8

            MOVLW   0xFF ;nic(puvodne3B pCS+zx_3)
            MOVWF   0x1A ;F9

            MOVLW   0x24 ;zx_6(puvodne34 pCS+zx_9)
            MOVWF   0x1B ;CURR LEFT

            MOVLW   0x1C ;zx_7(puvodne2C pCS+zx_0)
            MOVWF   0x1C ;CURR RIGHT

            MOVLW   0x0C ;zx_9(puvodne5A pSS+zx_Q)
            MOVWF   0x1D ;CURR UP

            MOVLW   0x14 ;zx_8(puvodne62 pSS+zx_E)
            MOVWF   0x1E ;CURR DOWN

            MOVLW   0x04 ;zx_0(puvodne43 pCS+zx_4)
            MOVWF   0x1F ;CTRL

            RETLW   0x00
;
;************
;************
;************
;
; Start systemu
;
;
Label_0001  MOVLW   0x0C
            MOVWF   PORTA
            MOVLW   0xF3
            TRIS    PORTA
            MOVLW   0x00
            MOVWF   PORTB
            MOVLW   0x00
            TRIS    PORTB
            MOVLW   0x2F
            OPTION
;
;**************
;
; Inicializacna pauza
;
            MOVLW   0x05
            MOVWF   0x0C

Label_0019  CLRF    0x21
Label_0018  CALL    Label_0006
            CLRWDT
            DECFSZ  0x21      , f
            GOTO    Label_0018
            DECFSZ  0x0C      , f
            GOTO    Label_0019
;
;**************
;
; Inicializacia programovatelnych klaves
;
Label_002D  CALL    Label_001A
;
;*********************
;
; Reset klavesnice
;
Label_0013  MOVLW   0xFF
            CALL    Label_001B
;
;**************
;
; Inicializacia premennych
;
Label_0031  CLRF    0x22
            BSF     0x22      , 01

Label_002F  CLRF    0x23
            CLRF    TMR0
            CALL    Label_001C
;
;****************
;
; Hlavna slucka
;
;
;****************
;****************
;
; Vyhodnotenie SCAN kodu
;
; -> upravuje kody do rozsahu 00..6F
; -> caka na klavesy, alebo povel
; -> sleduje NUM lock, meni bit PNUM a pri mode ZX aj meni LED
;
Label_0023  BCF     STATUS    , IRP
            BCF     STATUS    , RP1

Label_001E  CALL    Label_000E

            MOVLW   0xE0
            SUBWF   0x0C      , W
            BTFSS   STATUS    , Z
            GOTO    Label_001D
            BSF     STATUS    , IRP
            GOTO    Label_001E

Label_001D  MOVLW   0xF0
            SUBWF   0x0C      , W
            BTFSS   STATUS    , Z
            GOTO    Label_001F
            BSF     STATUS    , RP1
            GOTO    Label_001E

Label_001F  MOVLW   0xE1
            SUBWF   0x0C      , W
            BTFSS   STATUS    , Z
            GOTO    Label_0020
;
;***
;
; Osetrenie sekvenice PAUSE
;
            CALL    Label_000C
            MOVLW   0xF0
            SUBWF   0x0C      , W
            BTFSS   STATUS    , Z
            GOTO    Label_0021

            BSF     STATUS    , RP1
            CALL    Label_000C
            CALL    Label_000C

Label_0021  CALL    Label_000C
            MOVLW   0x0F
            GOTO    Label_0022

Label_0020  MOVLW   0xAA
            SUBWF   0x0C      , W
            BTFSC   STATUS    , Z
            GOTO    Label_0023

            BTFSS   STATUS    , IRP
            GOTO    Label_0024
;
;***
;
; Spracovanie - konverzia kodov s prefixom E0
;
            MOVLW   0x12
            SUBWF   0x0C      , W
            BTFSC   STATUS    , Z
            GOTO    Label_0023

            CLRF    0x21
            MOVLW   0x18
            CALL    Label_0025
;
;***
;
; Nasleduje konverzia kodov s hodnotou >6F
;
Label_0024  MOVLW   0x83
            SUBWF   0x0C      , W
            MOVLW   0x02
            BTFSC   STATUS    , Z
            GOTO    Label_0022

            MOVLW   0x84
            SUBWF   0x0C      , W
            MOVLW   0x5F
            BTFSC   STATUS    , Z
            GOTO    Label_0022

            MOVLW   0x70
            SUBWF   0x0C      , W
            BTFSS   STATUS    , C
            GOTO    Label_0026

            ANDLW   0x1F
            CALL    Label_0027

Label_0022  MOVWF   0x0C
;
;***
;
; Nastavenie priznakov pALT, pCTRL, pSH
;
Label_0026  MOVLW   0x11
            SUBWF   0x0C      , W
            MOVLW   0x80
            BTFSC   STATUS    , Z
            GOTO    Label_0028

            MOVLW   0x14
            SUBWF   0x0C      , W
            MOVLW   0x40
            BTFSC   STATUS    , Z
            GOTO    Label_0028

            MOVLW   0x12
            SUBWF   0x0C      , W
Label_0029  MOVLW   0x20
            BTFSC   STATUS    , Z
            GOTO    Label_0028

            MOVLW   0x59
            SUBWF   0x0C      , W
            BTFSC   STATUS    , Z
            GOTO    Label_0029

            GOTO    Label_002A
;
; Nastav bity vo FLAG podla masky W na hodnotu pF0
;
Label_0028  IORWF   0x22      , f
            BTFSC   STATUS    , RP1
            XORWF   0x22      , f
;
;****************
;****************
;
; Vyhodnotenie kombinacie ALT+...
;
Label_002A  BTFSC   STATUS    , RP1
            GOTO    Label_002B
            BTFSS   0x22      , 07
            GOTO    Label_002B

            MOVLW   0x5F
            SUBWF   0x0C      , W
            BTFSS   STATUS    , Z
            GOTO    Label_002C
;
; Aktivacia NMI
;
            MOVLW   0xC2
            MOVWF   PORTB
            BCF     0x22      , 07
            CLRF    PORTB
            GOTO    Label_0023
;
;**
;
; CTRL+ALT+DEL
;
Label_002C  BTFSS   0x22      , 06
            GOTO    Label_002B

            MOVLW   0x13
            SUBWF   0x0C      , W
            BTFSC   STATUS    , Z
            GOTO    Label_002D

            MOVLW   0x20
            SUBWF   0x0C      , W
            BTFSC   STATUS    , Z
            GOTO    Label_002E

            MOVLW   0x6F
            SUBWF   0x0C      , W

            BTFSS   STATUS    , Z
            GOTO    Label_002B
;
; RESET pocitaca a klavesnice - PK sa nemenia
;
Label_002E  MOVLW   0xC1
            MOVWF   PORTB

            MOVLW   0xFF
            CALL    Label_001B

            MOVLW   0x06
            ANDWF   0x22      , f
            GOTO    Label_002F
;
;******************
;
; Vetvenie podla modu 
;
Label_002B  BTFSC   0x22      , 00
            GOTO    Label_0030
;
;******************
;******************
;
; ZX-mod
;
;******************
;
; Nastavenie modu z klavesnice
;
            MOVF    0x0C      , f
            BTFSC   STATUS    , Z
            GOTO    Label_0031

            BTFSC   0x22      , 05
            GOTO    Label_0032
            BTFSS   0x22      , 07
            GOTO    Label_0033

Label_0032  MOVLW   0x09
            SUBWF   0x0C      , W
            MOVLW   0x02
            BTFSC   STATUS    , Z
            GOTO    Label_0034
            MOVLW   0x08
            SUBWF   0x0C      , W
            MOVLW   0x04
            BTFSC   STATUS    , Z
            GOTO    Label_0034
            MOVLW   0x07
            SUBWF   0x0C      , W
            BTFSS   STATUS    , Z
            GOTO    Label_0033
            MOVLW   0x08
;
; Nastavenie modu z klavesnice
;
Label_0034  IORWF   0x22      , f
            BTFSS   0x22      , 07
            XORWF   0x22      , f
            CALL    Label_001C
            GOTO    Label_0023

Label_0033  MOVLW   0x13
            SUBWF   0x0C      , W
            BTFSS   STATUS    , Z
            GOTO    Label_0035
;
; Stlacena klavesa ESC. 
; Nuluje sa matica a priznaky FLAG2
;
            CALL    Label_001C
            MOVLW   0x2F

Label_0038  MOVWF   0x0C
            GOTO    Label_0036

Label_0035  BTFSC   0x22      , 03 ; zmeneno BTFSS(jnb na jb)
            GOTO    Label_0037
;
; Konverzia klaves CTRL,UP,DW,LF,RG na KURZORY(puv.sinclair JOY)
;
            MOVLW   0x14   ;kod 14=CTRL
            SUBWF   0x0C      , W
            MOVLW   0x0F   ;bude zx SS
            BTFSC   STATUS    , Z
            GOTO    Label_0038

            MOVLW   0x3F   ;kod 3F=UP
            SUBWF   0x0C      , W
            MOVLW   0x44   ;bude zx UP
            BTFSC   STATUS    , Z
            GOTO    Label_0038

            MOVLW   0x40   ;kod 40=DOWN
            SUBWF   0x0C      , W
            MOVLW   0x4C   ;bude zx DOWN
            BTFSC   STATUS    , Z
            GOTO    Label_0038

            MOVLW   0x38   ;kod 38=LEFT
            SUBWF   0x0C      , W
            MOVLW   0x4B   ;bude zx LEFT
            BTFSC   STATUS    , Z
            GOTO    Label_0038

            MOVLW   0x39   ;kod 39=RIGHT
            SUBWF   0x0C      , W
            MOVLW   0x3C   ;bude zx RIGHT
            BTFSC   STATUS    , Z
            GOTO    Label_0038
;
;***
;
Label_0037  BTFSS   0x23      , 04
            BTFSC   0x22      , 05
            GOTO    Label_0039
;
;***
;
; Vyhodnotenie klavesy bez konverzie
;
Label_0047  CALL    Label_003A
            MOVWF   0x0C
            INCF    0x0C      , W
            BTFSC   STATUS    , Z
            GOTO    Label_003B
            MOVLW   0xF0
            SUBWF   0x0C      , W
            BTFSS   STATUS    , C
            GOTO    Label_003C
            MOVWF   FSR
            MOVLW   0x12
            ADDWF   FSR       , f
            MOVF    INDF      , W
            MOVWF   0x0C
            MOVLW   0xF0
            SUBWF   0x0C      , W
            BTFSC   STATUS    , C
            GOTO    Label_003B
Label_003C  MOVLW   0x78
            SUBWF   0x0C      , W
            BTFSC   STATUS    , C
            GOTO    Label_003D
Label_0036  MOVLW   0x50
            SUBWF   0x0C      , W
            BTFSS   STATUS    , C
            GOTO    Label_003E
            MOVWF   0x0C
            BCF     0x0E      , 07
            BTFSS   STATUS    , RP1
            BSF     0x0E      , 07
            GOTO    Label_003F
Label_003E  MOVLW   0x28
            SUBWF   0x0C      , W
            BTFSS   STATUS    , C
            GOTO    Label_0040
            MOVWF   0x0C
            BCF     0x0D      , 00
            MOVLW   0x23
            SUBWF   0x0C      , W
            MOVLW   0x02
            BTFSC   STATUS    , Z
            GOTO    Label_0041
            MOVLW   0x24
            SUBWF   0x0C      , W
            MOVLW   0x04
            BTFSC   STATUS    , Z
            GOTO    Label_0041
            MOVLW   0x1C
            SUBWF   0x0C      , W
            MOVLW   0x08
            BTFSC   STATUS    , Z
            GOTO    Label_0041
            MOVLW   0x14
            SUBWF   0x0C      , W
            MOVLW   0x01
            BTFSS   STATUS    , Z
            GOTO    Label_0042
Label_0041  IORWF   0x23      , f
            BTFSC   STATUS    , RP1
            XORWF   0x23      , f
Label_0042  CALL    Label_0043
Label_003F  CALL    Label_0044
            CALL    Label_0045
Label_0040  MOVF    0x0C      , W
            CALL    Label_0046
            MOVWF   0x21
            RLF     0x0C      , f
            SWAPF   0x0C      , W
            ANDLW   0x07
            MOVWF   FSR
            MOVLW   0x0D
            ADDWF   FSR       , f
            MOVF    0x21      , W
            IORWF   INDF      , f
            BTFSC   STATUS    , RP1
            XORWF   INDF      , f
Label_003B  CALL    Label_0044
            GOTO    Label_0023
Label_0039  MOVLW   0x18
            MOVWF   0x21
            MOVLW   0x16
            BTFSS   0x22      , 01
            MOVLW   0x2A
            CALL    Label_0025
            BTFSS   0x20      , 00
            GOTO    Label_0047
            BTFSS   STATUS    , RP1
            GOTO    Label_0048
            MOVF    0x24      , W
            SUBWF   0x0C      , W
            BTFSC   STATUS    , Z
            GOTO    Label_0049
            INCF    0x20      , f
            CALL    Label_0009
            GOTO    Label_0047
Label_0049  BCF     0x23      , 04
            CALL    Label_0043
            GOTO    Label_004A
Label_0048  BTFSS   0x23      , 04
            BTFSC   0x23      , 05
            GOTO    Label_003B
            BCF     0x0D      , 00
            BSF     0x23      , 04
            MOVF    0x0C      , W
            MOVWF   0x24
Label_004A  MOVLW   0x78
            SUBWF   0x0C      , W
            BTFSS   STATUS    , C
            GOTO    Label_0036
            GOTO    Label_004B
Label_003D  BTFSC   0x23      , 04
            GOTO    Label_003B
Label_004B  MOVWF   0x20
            MOVF    0x0C      , W
            BTFSS   STATUS    , RP1
            GOTO    Label_004C
            SUBWF   0x24      , W
            BTFSS   STATUS    , Z
            GOTO    Label_003B
            BCF     0x23      , 05
            MOVF    0x20      , W
            MOVWF   0x0C
            GOTO    Label_0036
Label_004C  BTFSC   0x23      , 05
            GOTO    Label_003B
            MOVWF   0x24
            BSF     0x23      , 05
            MOVF    0x20      , W
            MOVWF   0x0C
            BTFSC   0x22      , 02
            GOTO    Label_0036
            BSF     0x0E      , 07
            BSF     0x0D      , 00
            CALL    Label_0044
            MOVLW   0x23
            CALL    Label_004D
            BCF     0x0E      , 07
            BCF     0x0D      , 00
            CALL    Label_0044
            CALL    Label_0045
            GOTO    Label_0036
Label_000F  CLRF    0x0C
            BTFSC   0x23      , 07
            GOTO    Label_004E
            MOVLW   0x3F
            SUBWF   TMR0      , W
            BTFSC   STATUS    , Z
            GOTO    Label_0001
            BTFSC   TMR0      , 07
            GOTO    Label_004F
            BTFSC   TMR0      , 06
            GOTO    Label_004F
            BTFSC   TMR0      , 05
            GOTO    Label_0050
            BTFSC   TMR0      , 04
            GOTO    Label_0051
            BTFSC   TMR0      , 03
            GOTO    Label_0052
            BTFSC   0x22      , 00
Label_005F  CALL    Label_0053
Label_004F  CLRF    TMR0
            GOTO    Label_000E
Label_0052  MOVLW   0xED
            CALL    Label_001B
            MOVF    TMR0      , W
            ANDLW   0x07
            CALL    Label_001B
            GOTO    Label_004F
Label_0050  MOVF    TMR0      , W
            ANDLW   0x0F
            MOVWF   0x20
            MOVLW   0x0E
            SUBWF   0x20      , W
            BTFSC   STATUS    , C
            GOTO    Label_004F
            MOVLW   0x12
            ADDWF   0x20      , W
            MOVWF   FSR
            MOVLW   0xFF
            MOVWF   INDF
            BSF     0x23      , 07
            GOTO    Label_004F
Label_004E  MOVLW   0x12
            MOVWF   FSR
            MOVLW   0x0E
            MOVWF   0x20
Label_0055  MOVLW   0xFF
            SUBWF   INDF      , W
            BTFSC   STATUS    , Z
            GOTO    Label_0054
            INCF    FSR       , f
            DECFSZ  0x20      , f
            GOTO    Label_0055
            GOTO    Label_0056
Label_0054  DECF    TMR0      , W
            MOVWF   INDF
Label_0056  BCF     0x23      , 07
            GOTO    Label_004F
Label_0051  BTFSS   0x22      , 00
            GOTO    Label_0057
            BTFSC   TMR0      , 00
            GOTO    Label_0057
            CALL    Label_001A
Label_0057  MOVF    TMR0      , W
            ANDLW   0x0F
            MOVWF   0x20
            MOVF    0x22      , W
            ANDLW   0xF0
            IORWF   0x20      , W
            MOVWF   0x22
            CALL    Label_001C
            BTFSS   0x22      , 00
            GOTO    Label_004F
            GOTO    Label_0058
Label_0053  MOVF    0x23      , W
            ANDLW   0x1F
            MOVWF   0x20
            MOVF    0x24      , W
            ANDLW   0x1F
            SUBWF   0x20      , W
            BTFSS   STATUS    , C
            GOTO    Label_0059
            CLRF    PORTB
            BSF     PORTB     , 06
            BCF     PORTB     , 06
            BCF     0x24      , 06
            RETLW   0x00
Label_0059  MOVLW   0x0D
            ADDWF   0x23      , W
            ANDLW   0x3F
            MOVWF   FSR
            MOVLW   0x01
            MOVWF   0x20
            CLRF    PORTB
            BCF     STATUS    , C
            BSF     0x24      , 06
Label_005A  MOVF    0x20      , W
            ANDWF   INDF      , W
            BTFSS   STATUS    , Z
            BSF     PORTB     , 05
            BSF     PORTB     , 07
            BCF     PORTB     , 07
            MOVLW   0x07
            ANDWF   PORTB     , f
            INCF    PORTB     , f
            RLF     0x20      , f
            BTFSS   STATUS    , C
            GOTO    Label_005A
            MOVLW   0x10
            BTFSC   0x24      , 07
            MOVLW   0x20
            MOVWF   PORTB
            BSF     PORTB     , 06
            BCF     PORTB     , 06
            INCF    0x23      , f
            MOVLW   0x80
            XORWF   0x24      , f
            RETLW   0x00
Label_0030  MOVF    0x0D      , W
            MOVWF   0x20
Label_005C  MOVF    0x20      , W
            ADDWF   0x23      , W
            ANDLW   0x1F
            BTFSC   STATUS    , Z
            GOTO    Label_005B
            MOVWF   FSR
            MOVF    INDF      , W
            MOVWF   0x21
            MOVF    0x20      , W
            MOVWF   FSR
            MOVF    0x21      , W
            MOVWF   INDF
            INCF    0x20      , f
            GOTO    Label_005C
Label_005B  MOVF    0x23      , W
            ANDLW   0x1F
            SUBWF   0x24      , f
            CLRF    0x23
            MOVF    0x24      , W
            ANDLW   0x1F
            MOVWF   0x20
            MOVLW   0x13
            SUBWF   0x20      , W
            BTFSC   STATUS    , Z
            GOTO    Label_005D
            MOVLW   0x0D
            ADDWF   0x24      , W
            MOVWF   FSR
            MOVF    0x0C      , W
            MOVWF   INDF
            BTFSC   STATUS    , RP1
            BSF     INDF      , 07
            INCF    0x24      , f
Label_005E  BTFSC   0x24      , 06
            GOTO    Label_0023
            CALL    Label_0053
            GOTO    Label_0023
Label_005D  CLRF    0x1F
            GOTO    Label_005E
Label_0058  MOVLW   0xF1
            MOVWF   0x0D
            MOVLW   0xF1
            MOVWF   0x0E
            MOVLW   0xF0
            MOVWF   0x0F
            CLRF    0x10
            CLRF    0x23
            MOVLW   0x04
            MOVWF   0x24
            GOTO    Label_005F
 
            ORG     0x2000
            DE      0x0F
            DE      0x0F
            DE      0x0F
            DE      0x0F
 
            ORG     0x2007
            DE      0x06
 

            END
